 ###############################################
#                                               #
#          H Y P E R C O N V E R T E R          #
#       v1.0 (28/05/2009)  par MenzAgitat       #
#                                               #
#          http://www.boulets-roxx.com          #
#        IRC:  irc.epiknet.org  #boulets        #
#              irc.teepi.net    #boulets        #
#                                               #
 ###############################################

#		Merci  CrazyCat et Galdinx pour m'avoir aid  rgler quelques problmes,
#		et  http://wiki.tcl.tk qui constitue pour moi une source d'inspiration
#		inpuisable.

#
#	Description :
#		Librairie de procdures de conversion entre diffrentes bases numriques,
#		de strings en hex/bin/oct et vice-versa, et de codes de contrle mirc en
#		octal (format eggdrop, par exemple "\00304" quivaut au code de couleur
#		rouge).
#
#		Inclut :	dec2bin dec2hex dec2oct
#							bin2dec bin2hex bin2oct bin2str
#							hex2dec hex2bin hex2oct hex2str
#							oct2bin oct2dec oct2hex oct2str
#							str2hex str2oct str2bin
#							mirc2egg
#
#		Il est possible d'activer des commandes publiques pour effectuer des
#		conversions directement sur le chan.
#		La procdure rpondant aux commandes publiques est dissocie des fonctions
#		de conversion de faon  ne pas les ralentir lorsque vous les utilisez
#		depuis un script.
#

#	Changelog :
#		1.0: tout (1re version)
#

#	LICENCE:
#		This program is free software; you can redistribute it and/or modify
#		it under the terms of the GNU General Public License as published by
#		the Free Software Foundation; either version 2 of the License, or
#		(at your option) any later version.
#
#		This program is distributed in the hope that it will be useful,
#		but WITHOUT ANY WARRANTY; without even the implied warranty of
#		MERCHANTABILITY or FITNESS FOR A RTICULAR PURPOSE.  See the
#		GNU General Public License for more details.
#

if { [lindex [split $version] 1] < 1061800 } { putloglev o * "\00304\002\[HyperConverter - ERREUR\]\002\003 La version de votre eggdrop est \00304\002[lindex [split $version] 0]\002\003; HyperConverter.tcl ne fonctionnera correctement que sur les eggdrops version 1.6.18 ou suprieure." ; return }
if { $tcl_version < 8.4 } { putloglev o * "\00304\002\[HyperConverter - ERREUR\]\002\003 HyperConverter.tcl ncessite que Tcl 8.4 (ou plus) soit install pour fonctionner. Votre version actuelle de Tcl est \00304\002$tcl_version\002\003." ; return }
package require Tcl 8.4
if {[info commands hyperconverter::uninstall] eq "::hyperconverter::uninstall"} { hyperconverter::uninstall }
namespace eval ::hyperconverter {

#############################
#	   		 PARAMETRES         #
#############################

	##### Activer les commandes publiques ? ( 1 = oui ; 0 = non )
	variable enable_public_cmds 1

	##### Autorisations ncessaires pour utiliser les commandes publiques
	variable cmds_authorizations "-|-"
	
	
	##### couleur des rsultats
	variable hyperconverter_color 14

	##### Chans sur lesquels Base Converter sera actif
	##### exemple : variable allowed_chans "#chan1 #chan2 #chan3"
	variable allowed_chans "#boulets"





################################################################
#                                                              #
# DO NOT MODIFY ANYTHING BELOW THIS BOX IF YOU DON'T KNOW TCL  #
#                                                              #
################################################################

	variable scriptname "HyperConverter"
	variable version "1.0.20090528"
	if { $enable_public_cmds } {
		bind pubm $::hyperconverter::cmds_authorizations "* %!dec2bin% *" ::hyperconverter::public_cmd
		bind pubm $::hyperconverter::cmds_authorizations "* %!dec2hex% *" ::hyperconverter::public_cmd
		bind pubm $::hyperconverter::cmds_authorizations "* %!dec2oct% *" ::hyperconverter::public_cmd
		bind pubm $::hyperconverter::cmds_authorizations "* %!bin2dec% *" ::hyperconverter::public_cmd
		bind pubm $::hyperconverter::cmds_authorizations "* %!bin2hex% *" ::hyperconverter::public_cmd
		bind pubm $::hyperconverter::cmds_authorizations "* %!bin2oct% *" ::hyperconverter::public_cmd
		bind pubm $::hyperconverter::cmds_authorizations "* %!bin2str% *" ::hyperconverter::public_cmd
		bind pubm $::hyperconverter::cmds_authorizations "* %!hex2dec% *" ::hyperconverter::public_cmd
		bind pubm $::hyperconverter::cmds_authorizations "* %!hex2bin% *" ::hyperconverter::public_cmd
		bind pubm $::hyperconverter::cmds_authorizations "* %!hex2oct% *" ::hyperconverter::public_cmd
		bind pubm $::hyperconverter::cmds_authorizations "* %!hex2str% *" ::hyperconverter::public_cmd
		bind pubm $::hyperconverter::cmds_authorizations "* %!oct2bin% *" ::hyperconverter::public_cmd
		bind pubm $::hyperconverter::cmds_authorizations "* %!oct2dec% *" ::hyperconverter::public_cmd
		bind pubm $::hyperconverter::cmds_authorizations "* %!oct2hex% *" ::hyperconverter::public_cmd
		bind pubm $::hyperconverter::cmds_authorizations "* %!oct2str% *" ::hyperconverter::public_cmd
		bind pubm $::hyperconverter::cmds_authorizations "* %!str2hex% *" ::hyperconverter::public_cmd
		bind pubm $::hyperconverter::cmds_authorizations "* %!str2oct% *" ::hyperconverter::public_cmd
		bind pubm $::hyperconverter::cmds_authorizations "* %!str2bin% *" ::hyperconverter::public_cmd
		bind pubm $::hyperconverter::cmds_authorizations "* %!mirc2egg% *" ::hyperconverter::public_cmd
	}
	bind evnt - prerehash hyperconverter::uninstall
	proc uninstall {args} {
		putlog "Dsallocation des ressources de \002$hyperconverter::scriptname...\002"
		foreach binding [lsearch -inline -all -regexp [binds *[set ns [string range [namespace current] 2 end]]*] " (::)?$ns"] {
			unbind [lindex $binding 0] [lindex $binding 1] [lindex $binding 2] [lindex $binding 4]
		}
		namespace delete ::hyperconverter
	}
}

proc hyperconverter::public_cmd {nick host hand chan arg} {
	if { [lsearch -exact $hyperconverter::allowed_chans $chan] == -1 } { return }
	if { [lsearch {!dec2bin !dec2hex !dec2oct !bin2dec !bin2hex !bin2oct !bin2str !hex2dec !hex2bin !hex2oct !hex2str !oct2bin !oct2dec !oct2hex !oct2str !str2hex !str2oct !str2bin !mirc2egg} [lindex [set arg [split $arg]] 0]] == -1 } { return }
	puthelp "PRIVMSG $chan :\003$hyperconverter::hyperconverter_color [::hyperconverter::[string range [lindex $arg 0] 1 end] [join [lrange $arg 1 end]]]"
}

## dcimal
proc hyperconverter::dec2bin dec2bin_dec {
	binary scan [binary format I [hyperconverter::trim_0 $dec2bin_dec]] B32 dec2bin_bin
	return $dec2bin_bin
}

proc hyperconverter::dec2hex dec2hex_dec {
	set hex [format %x [hyperconverter::trim_0 $dec2hex_dec]]
	set half_length [expr [string length $hex] / 2]
	if { [expr $half_length %2] } { return "0$hex" } { return $hex }
}

proc hyperconverter::dec2oct dec2oct_dec {
	return [format %o [hyperconverter::trim_0 $dec2oct_dec]]
}

## binaire
proc hyperconverter::bin2dec bin2dec_bin {
	return [hyperconverter::hex2dec [hyperconverter::bin2hex $bin2dec_bin]]
}

proc hyperconverter::bin2hex bin2hex_binary {
	array set bin2hex_array {
		0000 0 0001 1 0010 2 0011 3 0100 4
		0101 5 0110 6 0111 7 1000 8 1001 9
		1010 a 1011 b 1100 c 1101 d 1110 e 1111 f
	}
	set bin2hex_diff [expr {4-[string length $bin2hex_binary]%4}]
	if {$bin2hex_diff != 4} {
		set bin2hex_binary [format %0${bin2hex_diff}d$bin2hex_binary 0]
	}
	regsub -all .... $bin2hex_binary {$bin2hex_array(&)} bin2hex_hexa
	set bin2hex_hexa [subst $bin2hex_hexa]
	set half_length [expr [string length $bin2hex_hexa] / 2]
	if { [expr $half_length %2] } { return "0$bin2hex_hexa" } { return $bin2hex_hexa }

}

proc hyperconverter::bin2oct bin2oct_bin {
	return [format %o [hyperconverter::hex2dec [hyperconverter::bin2hex $bin2oct_bin]]]
}

## hexadcimal
proc hyperconverter::hex2dec hex2dec_hexa {
	return [expr 0x$hex2dec_hexa]
}

proc hyperconverter::hex2bin hex2bin_hexa {
	array set hex2bin_array {
		0 0000 1 0001 2 0010 3 0011 4 0100
		5 0101 6 0110 7 0111 8 1000 9 1001
		a 1010 b 1011 c 1100 d 1101 e 1110 f 1111
		A 1010 B 1011 C 1100 D 1101 E 1110 F 1111
	}
	regsub {^0[xX]} $hex2bin_hexa {} hex2bin_hexa
	regsub -all . $hex2bin_hexa {$hex2bin_array(&)} hex2bin_binary
	return [subst $hex2bin_binary]
}

proc hyperconverter::hex2oct hex2oct_hex {
	return [hyperconverter::dec2oct [hyperconverter::hex2dec $hex2oct_hex]]
}

## octal
proc hyperconverter::oct2bin oct2bin_oct {
	return [hyperconverter::dec2bin [hyperconverter::oct2dec $oct2bin_oct]]
}

proc hyperconverter::oct2dec oct2dec_oct {
	return [format %i "0$oct2dec_oct"]
}

proc hyperconverter::oct2hex oct2hex_oct {
	return [hyperconverter::dec2hex [hyperconverter::oct2dec $oct2hex_oct]]
}

## strings
proc hyperconverter::str2hex str2hex_str {
	if { [lindex [info level -1] 0] ne "::hyperconverter::public_cmd" } {
		binary scan $str2hex_str H* hex
	} else {
		foreach char [split $str2hex_str ""] {
			binary scan $char H* hex_char
			lappend hex $hex_char
		}
	}
	return $hex
}

proc hyperconverter::str2bin str2bin_str {
	return [hyperconverter::hex2bin [hyperconverter::str2hex $str2bin_str]]
}

proc hyperconverter::str2oct str2oct_str {
	return [hyperconverter::hex2oct [hyperconverter::str2hex $str2oct_str]]
}

proc hyperconverter::hex2str hex2str_hex {
	set hex2str_hex [string trim [join [split $hex2str_hex] ""]]
	foreach c [split $hex2str_hex ""] {
		if {![string is xdigit $c]} {
			return
		}
	}
	return [binary format H* $hex2str_hex]
}

proc hyperconverter::bin2str bin2str_bin {
	return [hyperconverter::hex2str [hyperconverter::bin2hex $bin2str_bin]]
}

proc hyperconverter::oct2str oct2str_oct {
	return [hyperconverter::hex2str [hyperconverter::oct2hex $oct2str_oct]]
}

proc hyperconverter::mirc2egg mirc2egg_mirc {
	return [string map -nocase {
		"\001"	"\\001"
		"\002"	"\\002"
		"\003"	"\\003"
		"\006"	"\\006"
		"\007"	"\\007"
		"\017"	"\\017"
		"\026"	"\\026"
		"\037"	"\\037"
	} $mirc2egg_mirc]
}

proc hyperconverter::trim_0 value {
	return [string trimleft $value "0"]
}


putlog "\002*$hyperconverter::scriptname v$hyperconverter::version*\002 par MenzAgitat a t charg."
